// MID-GARTS t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "d88.h"

unsigned char buff[0x400*8*154];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size);
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[16];
	unsigned char id[]="DISK";
	int i,d;

	struct fpos md[] =
	{
		{ 0x2a, 0x01, 0x1000 }, // 01
		{ 0x2a, 0x05, 0x1000 }, // 02
		{ 0x2a, 0x07, 0x0800 }, // 03
		{ 0x2b, 0x01, 0x2000 }, // 04
		{ 0x2c, 0x01, 0x1000 }, // 05
		{ 0x2c, 0x03, 0x0800 }, // 06
		{ 0x2c, 0x05, 0x0800 }, // 07
		{ 0x2c, 0x07, 0x1000 }, // 08
		{ 0x2d, 0x03, 0x1000 }, // 09
		{ 0x2d, 0x07, 0x0800 }, // 10
		{ 0x2e, 0x01, 0x2000 }, // 11
		{ 0x2f, 0x01, 0x1000 }, // 12
		{ 0x2f, 0x05, 0x1000 }, // 13
		{ 0x30, 0x01, 0x2000 }, // 14
		{ 0x31, 0x01, 0x0800 }, // 15
		{ 0x31, 0x03, 0x1000 }, // 16
		{ 0x31, 0x07, 0x1000 }, // 17
		{ 0x32, 0x03, 0x0800 }, // 18
		{ 0x32, 0x05, 0x0800 }, // 19
		{ 0x32, 0x07, 0x0800 }, // 20
		{ 0x33, 0x01, 0x0800 }, // 21
		{ 0x33, 0x03, 0x1000 }, // 22
		{ 0x33, 0x07, 0x0800 }, // 23
		{ 0x34, 0x01, 0x0800 }, // 24
		{ 0x34, 0x03, 0x1000 }, // 25
		{ 0x34, 0x07, 0x1000 }, // 26
		{ 0x35, 0x03, 0x1000 }, // 27
		{ 0x35, 0x07, 0x0800 }, // 28
		{ 0x36, 0x01, 0x0800 }, // 29
		{ 0x36, 0x03, 0x0800 }, // 30
		{ 0x36, 0x05, 0x1000 }, // 31
		{ 0x37, 0x01, 0x0800 }, // 32
		{ 0x37, 0x03, 0x0800 }, // 33
		{ 0x37, 0x05, 0x1000 }, // 34
		{ 0x38, 0x01, 0x1000 }, // 35
		{ 0x38, 0x05, 0x1000 }, // 36
		{ 0x39, 0x01, 0x0800 }, // 37
		{ 0x39, 0x03, 0x2800 }, // 38
		{ 0x3a, 0x05, 0x0800 }, // 39
		{ 0x3a, 0x07, 0x2000 }, // 40
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}
	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d); 
		disk.SetRecordRange(0x01,0x08);

		// fBXN
		disk.ReadDATA(0x00, 0x00, 0, 0x06, 0x03, buff, 0x20);
		if (!memcmp(buff,id,sizeof(id)-1))
		{
			printf("Disk %cF܂.\n",buff[4]);
			if (buff[4]=='1')
			{
				fcut("DRIVER", 0x06, 0x03, 0, 0x04, 0x03, 0x0000, 0x2400);
				fcut("MUS00",  0x58, 0x2c, 0, 0x08, 0x03, 0x0000, 0x2000);
			}
			else if (buff[4]=='2')
			{
				for (i=0; md[i].sec; i++)
				{
					sprintf(fname,"MUS%02d",i+1);
					fcut(fname, md[i].trk, md[i].trk>>1, md[i].trk&1, md[i].sec, 0x03, 0, md[i].size);
				}
			}
		}
	}
	return 0;
}

